﻿using DocumentFormat.OpenXml.InkML;
using Microsoft.AspNetCore.Http;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Application.BusinessFilter;

public class EncryptionRequestMiddleware
{
    private readonly RequestDelegate _next;

    public EncryptionRequestMiddleware(RequestDelegate next)
    {
        _next = next;
    }

    public async Task InvokeAsync(HttpContext context)
    {
        // 检查请求头中是否包含加密的对称密钥
        if (context.Request.Headers.ContainsKey("X-Encrypted-Key"))
        {
            var encryptedSymmetricKey = Convert.FromBase64String(context.Request.Headers["X-Encrypted-Key"]);

            //// 使用私钥解密对称密钥
            //var decryptedSymmetricKey = RsaEncryptionHelper.DecryptRsa(encryptedSymmetricKey, _rsaPrivateKey);
            //var aesKey = decryptedSymmetricKey[..32]; // 前32字节作为AES密钥
            //var aesIv = decryptedSymmetricKey[32..];  // 后面16字节作为IV

            //// 读取并解密请求体中的JSON数据
            //context.Request.EnableBuffering();
            //using (var reader = new StreamReader(context.Request.Body, Encoding.UTF8, leaveOpen: true))
            //{
            //    var encryptedBody = await reader.ReadToEndAsync();
            //    context.Request.Body.Position = 0;

            //    // 尝试解析为JObject
            //    var encryptedJson = JObject.Parse(encryptedBody);
            //    var decryptedJson = new JObject();

            //    // 解密每个字段的值
            //    foreach (var property in encryptedJson.Properties())
            //    {
            //        var encryptedValue = property.Value.ToString();
            //        var decryptedValue = AesEncryptionHelper.DecryptString(encryptedValue, aesKey, aesIv);
            //        decryptedJson[property.Name] = decryptedValue;
            //    }

            //    // 将解密后的JSON对象转换回字符串，并替换原始请求体
            //    var decryptedBody = decryptedJson.ToString();
            //    var bodyStream = new MemoryStream(Encoding.UTF8.GetBytes(decryptedBody));
            //    context.Request.Body = bodyStream;
            //    context.Request.ContentLength = bodyStream.Length;
            //    bodyStream.Seek(0, SeekOrigin.Begin);
        }


        // 调用下一个中间件
        await _next(context);
    }



}
